(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.Interactor = {}));
}(this, (function (exports) { 'use strict';

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  var defineProperty = _defineProperty;

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  var arrayWithHoles = _arrayWithHoles;

  function _iterableToArrayLimit(arr, i) {
    if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  var iterableToArrayLimit = _iterableToArrayLimit;

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }

  var arrayLikeToArray = _arrayLikeToArray;

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return arrayLikeToArray(o, minLen);
  }

  var unsupportedIterableToArray = _unsupportedIterableToArray;

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var nonIterableRest = _nonIterableRest;

  function _slicedToArray(arr, i) {
    return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || unsupportedIterableToArray(arr, i) || nonIterableRest();
  }

  var slicedToArray = _slicedToArray;

  var now = Date.now;
  var random = Math.random,
      round = Math.round;
  var assign = Object.assign,
      create = Object.create,
      defineProperty$1 = Object.defineProperty,
      defineProperties = Object.defineProperties,
      entries = Object.entries,
      freeze = Object.freeze,
      getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor,
      getOwnPropertyDescriptors = Object.getOwnPropertyDescriptors,
      getPrototypeOf = Object.getPrototypeOf;
  function named(name, fn) {
    return defineProperty$1(fn, 'name', {
      value: name
    });
  }
  function map(obj, fn) {
    return !obj ? {} : entries(obj).reduce(function (result, _ref) {
      var _ref2 = slicedToArray(_ref, 2),
          k = _ref2[0],
          v = _ref2[1];

      var value = fn(v, k);
      return value != null ? assign(result, defineProperty({}, k, value)) : result;
    }, create(null));
  }
  function mapPropertyDescriptors(obj, fn) {
    var descr = getOwnPropertyDescriptors(obj);
    var proto = getPrototypeOf(obj);

    while (proto && proto !== Object.prototype) {
      descr = assign(getOwnPropertyDescriptors(proto), descr);
      proto = getPrototypeOf(proto);
    }

    return map(descr, fn);
  }

  var sym = Symbol('interactor.meta');
  var m = {
    get: function get(inst, key) {
      var meta = (inst === null || inst === void 0 ? void 0 : inst[sym]) || {};
      return key ? meta[key] : meta;
    },
    set: function set(inst, key, val) {
      if (typeof key === 'string') {
        return m.set(inst, defineProperty({}, key, val));
      }

      return defineProperty$1(inst, sym, {
        enumerable: false,
        configurable: true,
        value: freeze(assign({
          id: round(random() * now())
        }, m.get(inst), map(key, function (next, key) {
          var prev = m.get(inst, key);

          switch (key) {
            case 'queue':
              return (prev || []).concat(next);

            case 'keyboard':
            case 'assertions':
            case 'children':
              return assign({}, prev, next);

            default:
              return next;
          }
        })))
      });
    },
    top: function top(inst, topmost) {
      var _m$get = m.get(inst),
          top = _m$get.top,
          parent = _m$get.parent;

      return !parent || !topmost && top ? inst : m.top(parent);
    },
    new: function _new(inst, key, val) {
      if (key === 'parent') {
        return m.new(inst, {
          parent: val,
          top: false
        });
      } else {
        return m.set(m.set(new inst.constructor(), m.get(inst)), key, val);
      }
    },
    eq: function eq(a, b) {
      return m.get(a, 'id') === m.get(b, 'id');
    }
  };

  function InteractorError(message) {
    var _Error$captureStackTr,
        _this = this;

    if (!(this instanceof InteractorError)) {
      return new InteractorError(message);
    }

    Error.prototype.constructor.call(this, message);
    (_Error$captureStackTr = Error.captureStackTrace) === null || _Error$captureStackTr === void 0 ? void 0 : _Error$captureStackTr.call(Error, this, InteractorError);
    defineProperties(this, {
      raw: {
        value: message
      },
      message: {
        configurable: true,
        get: function get() {
          return _this.ctx && _this.format().message || _this.raw;
        }
      }
    });
  }
  defineProperties(InteractorError, {
    prototype: {
      value: create(Error.prototype)
    }
  });
  defineProperties(InteractorError.prototype, {
    constructor: {
      value: InteractorError
    },
    name: {
      get: function get() {
        return this.constructor.name;
      }
    },
    bind: {
      value: function value(ctx, expected) {
        return this.ctx ? this : defineProperties(this, {
          ctx: {
            value: ctx
          },
          expected: {
            value: expected
          }
        });
      }
    },
    format: {
      value: function value() {
        var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '%{e}';
        return defineProperties(this, {
          message: {
            value: format(message.replace('%{e}', this.raw), this.ctx, this.expected)
          }
        });
      }
    }
  });
  var regexDF = new RegExp('%{((?:%{.*?}|.)*?)}', 'gs');
  var regexNS = new RegExp('^(true|false|undefined|null|[\\d.,]+|\\[.*\\]|{.*})$');
  var regexES = new RegExp('\\s{2,}', 'g');

  function format(message, inst, expected) {
    return message.replace(regexDF, function (_, f) {
      var arg = f.substr(1).trim();

      if (regexDF.test(arg)) {
        arg = format(arg, inst, expected);
      }

      switch (f[0]) {
        case '@':
          return arg ? "".concat(arg, " within ").concat(inst) : inst.toString();

        case '-':
          return arg.split('|')[expected ? 0 : 1] || '';

        case '"':
          return !regexNS.test(arg) ? "\"".concat(arg, "\"") : arg;

        default:
          return '';
      }
    }).replace(regexES, ' ').trim();
  }

  function assertion(get) {
    var matcher = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : get;
    get = matcher === get ? null : get;
    return function (expected) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      if (get) {
        var value = get.apply(this, args.slice(0, get.length));
        args = [value].concat(args);
      }

      var _matcher$apply = matcher.apply(this, args),
          message = _matcher$apply.message,
          result = _matcher$apply.result;

      if (result !== expected) {
        throw InteractorError(message);
      }
    };
  }
  function createAssert(name, fn) {
    return named(name, assertion(fn, function (actual) {
      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      var what = (fn === null || fn === void 0 ? void 0 : fn.length) ? args[0] : name;
      var message = "%{@} ".concat(what, " is %{\"").concat(actual, "}");
      var expected = args[(fn === null || fn === void 0 ? void 0 : fn.length) || 0];
      var result = !!actual;

      if (expected != null) {
        message += " but expected %{- %{\"".concat(expected, "}|it not to be}");

        if (typeof actual === 'string' && expected instanceof RegExp) {
          result = expected.test(actual);
        } else if (typeof expected === 'function') {
          result = expected.call(this, actual);
          result = typeof result === 'undefined' || result;
        } else {
          result = actual === expected;
        }
      } else if (typeof actual === 'boolean') {
        message = "%{@} is %{- not} ".concat(what);
      }

      return {
        message: message,
        result: result
      };
    }));
  }

  function ctxError() {
    throw InteractorError('interactor methods should not be called within assertions');
  }

  function mapAssertMethods(assert, expected, ctx) {
    var negated = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : !expected;
    return function (fn, name) {
      return {
        value: function value() {
          for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          return assert(named("assert".concat(negated ? '.not' : '', ".").concat(name), function () {
            var c = ctx || context(this, expected);

            for (var _len4 = arguments.length, a = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
              a[_key4] = arguments[_key4];
            }

            c.assert(fn.bind.apply(fn, [c, expected].concat(args, a)));
          }));
        }
      };
    };
  }

  function mapAssertChildren(assert, inst, negated) {
    return function (child, name) {
      return defineProperty({}, typeof child === 'function' ? 'value' : 'get', named("assert".concat(negated ? '.not' : '', ".").concat(name), function () {
        for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
          args[_key5] = arguments[_key5];
        }

        return assert(m.new(typeof child === 'function' ? child.apply(m.new(inst, 'top', true), args) : child, 'parent', inst));
      }));
    };
  }

  function context(i, expected, negated) {
    var proto = i.constructor.prototype;

    var _m$get = m.get(proto.assert),
        assertions = _m$get.assertions,
        children = _m$get.children;

    var ctx = create(i, mapPropertyDescriptors(proto, function (_ref2, key) {
      var get = _ref2.get,
          value = _ref2.value;
      if (['constructor', '$', '$$', 'assert'].includes(key)) return;

      if (['timeout', 'exec', 'catch', 'then'].includes(key)) {
        return {
          value: ctxError
        };
      }

      return defineProperty({}, get ? 'get' : 'value', function () {
        for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
          args[_key6] = arguments[_key6];
        }

        var ret = (get || value).apply(this, args);
        return m.get(ret, 'queue') ? context(ret, expected) : ret;
      });
    }));
    defineProperties(ctx, {
      assert: {
        value: function value(f) {
          if (m.get(f, 'queue')) {
            return context(f, expected, negated).assert;
          }

          try {
            f.apply(this);
          } catch (err) {
            if (err.name === 'InteractorError') err.bind(this, expected);
            throw err;
          }

          return this;
        }
      }
    });
    defineProperties(ctx.assert, assign(map(assertions, mapAssertMethods(function (f) {
      return f();
    }, expected, ctx, negated)), map(children, mapAssertChildren(ctx.assert, i, negated))));

    if (!negated) {
      defineProperty$1(ctx.assert, 'not', {
        get: function get() {
          return context(i, !expected, true).assert;
        }
      });
    }

    return ctx;
  }

  function InteractorAssert(i) {
    var expected = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var passert = i.constructor.prototype.assert;

    var _m$get2 = m.get(passert),
        assertions = _m$get2.assertions,
        children = _m$get2.children;

    var assert = function assert(f) {
      if (m.get(f, 'queue')) {
        return InteractorAssert(f, expected);
      }

      return passert.call(i, defineProperties(function () {
        try {
          f.apply(context(this, expected), arguments);
          if (expected) return;
        } catch (err) {
          if (err.name === 'InteractorError') err.bind(this, expected);
          if (expected) throw err;
          return;
        }

        throw InteractorError('expected assertion to fail but it passed');
      }, {
        name: {
          value: f.name
        },
        length: {
          value: f.length
        }
      }));
    };

    defineProperties(assert, assign(map(assertions, mapAssertMethods(passert.bind(i), expected)), map(children, mapAssertChildren(assert, i, !expected))));

    if (expected) {
      defineProperties(assert, {
        not: {
          get: function get() {
            return InteractorAssert(i, false);
          }
        },
        remains: {
          value: function remains() {
            var _q;

            var ms = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 500;
            var q = m.get(i, 'queue');

            if (((_q = q[q.length - 1]) === null || _q === void 0 ? void 0 : _q.type) !== 'assert') {
              throw InteractorError('no previous assertion to persist');
            }

            return m.new(i, 'queue', {
              type: 'assert',
              remains: ms
            });
          }
        }
      });
    }

    return assert;
  }

  function createCommonjsModule(fn, basedir, module) {
  	return module = {
  		path: basedir,
  		exports: {},
  		require: function (path, base) {
  			return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
  		}
  	}, fn(module, module.exports), module.exports;
  }

  function commonjsRequire () {
  	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
  }

  var _typeof_1 = createCommonjsModule(function (module) {
    function _typeof(obj) {
      "@babel/helpers - typeof";

      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        module.exports = _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        module.exports = _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }

      return _typeof(obj);
    }

    module.exports = _typeof;
  });

  var runtime_1 = createCommonjsModule(function (module) {
    var runtime = function (exports) {

      var Op = Object.prototype;
      var hasOwn = Op.hasOwnProperty;
      var undefined$1;
      var $Symbol = typeof Symbol === "function" ? Symbol : {};
      var iteratorSymbol = $Symbol.iterator || "@@iterator";
      var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
      var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

      function wrap(innerFn, outerFn, self, tryLocsList) {
        var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
        var generator = Object.create(protoGenerator.prototype);
        var context = new Context(tryLocsList || []);
        generator._invoke = makeInvokeMethod(innerFn, self, context);
        return generator;
      }

      exports.wrap = wrap;

      function tryCatch(fn, obj, arg) {
        try {
          return {
            type: "normal",
            arg: fn.call(obj, arg)
          };
        } catch (err) {
          return {
            type: "throw",
            arg: err
          };
        }
      }

      var GenStateSuspendedStart = "suspendedStart";
      var GenStateSuspendedYield = "suspendedYield";
      var GenStateExecuting = "executing";
      var GenStateCompleted = "completed";
      var ContinueSentinel = {};

      function Generator() {}

      function GeneratorFunction() {}

      function GeneratorFunctionPrototype() {}

      var IteratorPrototype = {};

      IteratorPrototype[iteratorSymbol] = function () {
        return this;
      };

      var getProto = Object.getPrototypeOf;
      var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

      if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
        IteratorPrototype = NativeIteratorPrototype;
      }

      var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
      GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
      GeneratorFunctionPrototype.constructor = GeneratorFunction;
      GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction";

      function defineIteratorMethods(prototype) {
        ["next", "throw", "return"].forEach(function (method) {
          prototype[method] = function (arg) {
            return this._invoke(method, arg);
          };
        });
      }

      exports.isGeneratorFunction = function (genFun) {
        var ctor = typeof genFun === "function" && genFun.constructor;
        return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
      };

      exports.mark = function (genFun) {
        if (Object.setPrototypeOf) {
          Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
        } else {
          genFun.__proto__ = GeneratorFunctionPrototype;

          if (!(toStringTagSymbol in genFun)) {
            genFun[toStringTagSymbol] = "GeneratorFunction";
          }
        }

        genFun.prototype = Object.create(Gp);
        return genFun;
      };

      exports.awrap = function (arg) {
        return {
          __await: arg
        };
      };

      function AsyncIterator(generator, PromiseImpl) {
        function invoke(method, arg, resolve, reject) {
          var record = tryCatch(generator[method], generator, arg);

          if (record.type === "throw") {
            reject(record.arg);
          } else {
            var result = record.arg;
            var value = result.value;

            if (value && _typeof_1(value) === "object" && hasOwn.call(value, "__await")) {
              return PromiseImpl.resolve(value.__await).then(function (value) {
                invoke("next", value, resolve, reject);
              }, function (err) {
                invoke("throw", err, resolve, reject);
              });
            }

            return PromiseImpl.resolve(value).then(function (unwrapped) {
              result.value = unwrapped;
              resolve(result);
            }, function (error) {
              return invoke("throw", error, resolve, reject);
            });
          }
        }

        var previousPromise;

        function enqueue(method, arg) {
          function callInvokeWithMethodAndArg() {
            return new PromiseImpl(function (resolve, reject) {
              invoke(method, arg, resolve, reject);
            });
          }

          return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
        }

        this._invoke = enqueue;
      }

      defineIteratorMethods(AsyncIterator.prototype);

      AsyncIterator.prototype[asyncIteratorSymbol] = function () {
        return this;
      };

      exports.AsyncIterator = AsyncIterator;

      exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
        if (PromiseImpl === void 0) PromiseImpl = Promise;
        var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
        return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
          return result.done ? result.value : iter.next();
        });
      };

      function makeInvokeMethod(innerFn, self, context) {
        var state = GenStateSuspendedStart;
        return function invoke(method, arg) {
          if (state === GenStateExecuting) {
            throw new Error("Generator is already running");
          }

          if (state === GenStateCompleted) {
            if (method === "throw") {
              throw arg;
            }

            return doneResult();
          }

          context.method = method;
          context.arg = arg;

          while (true) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if (context.method === "next") {
              context.sent = context._sent = context.arg;
            } else if (context.method === "throw") {
              if (state === GenStateSuspendedStart) {
                state = GenStateCompleted;
                throw context.arg;
              }

              context.dispatchException(context.arg);
            } else if (context.method === "return") {
              context.abrupt("return", context.arg);
            }

            state = GenStateExecuting;
            var record = tryCatch(innerFn, self, context);

            if (record.type === "normal") {
              state = context.done ? GenStateCompleted : GenStateSuspendedYield;

              if (record.arg === ContinueSentinel) {
                continue;
              }

              return {
                value: record.arg,
                done: context.done
              };
            } else if (record.type === "throw") {
              state = GenStateCompleted;
              context.method = "throw";
              context.arg = record.arg;
            }
          }
        };
      }

      function maybeInvokeDelegate(delegate, context) {
        var method = delegate.iterator[context.method];

        if (method === undefined$1) {
          context.delegate = null;

          if (context.method === "throw") {
            if (delegate.iterator["return"]) {
              context.method = "return";
              context.arg = undefined$1;
              maybeInvokeDelegate(delegate, context);

              if (context.method === "throw") {
                return ContinueSentinel;
              }
            }

            context.method = "throw";
            context.arg = new TypeError("The iterator does not provide a 'throw' method");
          }

          return ContinueSentinel;
        }

        var record = tryCatch(method, delegate.iterator, context.arg);

        if (record.type === "throw") {
          context.method = "throw";
          context.arg = record.arg;
          context.delegate = null;
          return ContinueSentinel;
        }

        var info = record.arg;

        if (!info) {
          context.method = "throw";
          context.arg = new TypeError("iterator result is not an object");
          context.delegate = null;
          return ContinueSentinel;
        }

        if (info.done) {
          context[delegate.resultName] = info.value;
          context.next = delegate.nextLoc;

          if (context.method !== "return") {
            context.method = "next";
            context.arg = undefined$1;
          }
        } else {
          return info;
        }

        context.delegate = null;
        return ContinueSentinel;
      }

      defineIteratorMethods(Gp);
      Gp[toStringTagSymbol] = "Generator";

      Gp[iteratorSymbol] = function () {
        return this;
      };

      Gp.toString = function () {
        return "[object Generator]";
      };

      function pushTryEntry(locs) {
        var entry = {
          tryLoc: locs[0]
        };

        if (1 in locs) {
          entry.catchLoc = locs[1];
        }

        if (2 in locs) {
          entry.finallyLoc = locs[2];
          entry.afterLoc = locs[3];
        }

        this.tryEntries.push(entry);
      }

      function resetTryEntry(entry) {
        var record = entry.completion || {};
        record.type = "normal";
        delete record.arg;
        entry.completion = record;
      }

      function Context(tryLocsList) {
        this.tryEntries = [{
          tryLoc: "root"
        }];
        tryLocsList.forEach(pushTryEntry, this);
        this.reset(true);
      }

      exports.keys = function (object) {
        var keys = [];

        for (var key in object) {
          keys.push(key);
        }

        keys.reverse();
        return function next() {
          while (keys.length) {
            var key = keys.pop();

            if (key in object) {
              next.value = key;
              next.done = false;
              return next;
            }
          }

          next.done = true;
          return next;
        };
      };

      function values(iterable) {
        if (iterable) {
          var iteratorMethod = iterable[iteratorSymbol];

          if (iteratorMethod) {
            return iteratorMethod.call(iterable);
          }

          if (typeof iterable.next === "function") {
            return iterable;
          }

          if (!isNaN(iterable.length)) {
            var i = -1,
                next = function next() {
              while (++i < iterable.length) {
                if (hasOwn.call(iterable, i)) {
                  next.value = iterable[i];
                  next.done = false;
                  return next;
                }
              }

              next.value = undefined$1;
              next.done = true;
              return next;
            };

            return next.next = next;
          }
        }

        return {
          next: doneResult
        };
      }

      exports.values = values;

      function doneResult() {
        return {
          value: undefined$1,
          done: true
        };
      }

      Context.prototype = {
        constructor: Context,
        reset: function reset(skipTempReset) {
          this.prev = 0;
          this.next = 0;
          this.sent = this._sent = undefined$1;
          this.done = false;
          this.delegate = null;
          this.method = "next";
          this.arg = undefined$1;
          this.tryEntries.forEach(resetTryEntry);

          if (!skipTempReset) {
            for (var name in this) {
              if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
                this[name] = undefined$1;
              }
            }
          }
        },
        stop: function stop() {
          this.done = true;
          var rootEntry = this.tryEntries[0];
          var rootRecord = rootEntry.completion;

          if (rootRecord.type === "throw") {
            throw rootRecord.arg;
          }

          return this.rval;
        },
        dispatchException: function dispatchException(exception) {
          if (this.done) {
            throw exception;
          }

          var context = this;

          function handle(loc, caught) {
            record.type = "throw";
            record.arg = exception;
            context.next = loc;

            if (caught) {
              context.method = "next";
              context.arg = undefined$1;
            }

            return !!caught;
          }

          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];
            var record = entry.completion;

            if (entry.tryLoc === "root") {
              return handle("end");
            }

            if (entry.tryLoc <= this.prev) {
              var hasCatch = hasOwn.call(entry, "catchLoc");
              var hasFinally = hasOwn.call(entry, "finallyLoc");

              if (hasCatch && hasFinally) {
                if (this.prev < entry.catchLoc) {
                  return handle(entry.catchLoc, true);
                } else if (this.prev < entry.finallyLoc) {
                  return handle(entry.finallyLoc);
                }
              } else if (hasCatch) {
                if (this.prev < entry.catchLoc) {
                  return handle(entry.catchLoc, true);
                }
              } else if (hasFinally) {
                if (this.prev < entry.finallyLoc) {
                  return handle(entry.finallyLoc);
                }
              } else {
                throw new Error("try statement without catch or finally");
              }
            }
          }
        },
        abrupt: function abrupt(type, arg) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];

            if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
              var finallyEntry = entry;
              break;
            }
          }

          if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
            finallyEntry = null;
          }

          var record = finallyEntry ? finallyEntry.completion : {};
          record.type = type;
          record.arg = arg;

          if (finallyEntry) {
            this.method = "next";
            this.next = finallyEntry.finallyLoc;
            return ContinueSentinel;
          }

          return this.complete(record);
        },
        complete: function complete(record, afterLoc) {
          if (record.type === "throw") {
            throw record.arg;
          }

          if (record.type === "break" || record.type === "continue") {
            this.next = record.arg;
          } else if (record.type === "return") {
            this.rval = this.arg = record.arg;
            this.method = "return";
            this.next = "end";
          } else if (record.type === "normal" && afterLoc) {
            this.next = afterLoc;
          }

          return ContinueSentinel;
        },
        finish: function finish(finallyLoc) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];

            if (entry.finallyLoc === finallyLoc) {
              this.complete(entry.completion, entry.afterLoc);
              resetTryEntry(entry);
              return ContinueSentinel;
            }
          }
        },
        "catch": function _catch(tryLoc) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];

            if (entry.tryLoc === tryLoc) {
              var record = entry.completion;

              if (record.type === "throw") {
                var thrown = record.arg;
                resetTryEntry(entry);
              }

              return thrown;
            }
          }

          throw new Error("illegal catch attempt");
        },
        delegateYield: function delegateYield(iterable, resultName, nextLoc) {
          this.delegate = {
            iterator: values(iterable),
            resultName: resultName,
            nextLoc: nextLoc
          };

          if (this.method === "next") {
            this.arg = undefined$1;
          }

          return ContinueSentinel;
        }
      };
      return exports;
    }( module.exports );

    try {
      regeneratorRuntime = runtime;
    } catch (accidentalStrictMode) {
      Function("r", "regeneratorRuntime = r")(runtime);
    }
  });

  var regenerator = runtime_1;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  var asyncToGenerator = _asyncToGenerator;

  function when(assertion) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        _ref$timeout = _ref.timeout,
        timeout = _ref$timeout === void 0 ? 2000 : _ref$timeout,
        _ref$interval = _ref.interval,
        interval = _ref$interval === void 0 ? 10 : _ref$interval,
        remains = _ref.remains;

    var then = function then() {
      var _Promise;

      return (_Promise = new Promise(function (resolve, reject) {
        return function () {
          var _retry = asyncToGenerator(regenerator.mark(function _callee(t, r) {
            var ret;
            return regenerator.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.prev = 0;
                    _context.next = 3;
                    return assertion();

                  case 3:
                    ret = _context.sent;

                    if (remains && (!r || now() - r <= remains)) {
                      setTimeout(retry, interval, t, r || now());
                    } else {
                      resolve(ret);
                    }

                    _context.next = 10;
                    break;

                  case 7:
                    _context.prev = 7;
                    _context.t0 = _context["catch"](0);

                    if (r || now() - t <= timeout) {
                      setTimeout(retry, interval, t);
                    } else {
                      reject(_context.t0);
                    }

                  case 10:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, null, [[0, 7]]);
          }));

          function retry(_x, _x2) {
            return _retry.apply(this, arguments);
          }

          return retry;
        }()(now());
      })).then.apply(_Promise, arguments);
    };

    return assign(then, {
      catch: function _catch(f) {
        return then().catch(f);
      },
      then: then
    });
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  var objectWithoutPropertiesLoose = _objectWithoutPropertiesLoose;

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};
    var target = objectWithoutPropertiesLoose(source, excluded);
    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  var objectWithoutProperties = _objectWithoutProperties;

  function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$1(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

  function _unsupportedIterableToArray$1(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$1(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$1(o, minLen); }

  function _arrayLikeToArray$1(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
  var RESERVED_PROPERTIES = ['$', '$$', 'assert', 'remains', 'not', 'exec', 'catch', 'then'];

  function reserved(name) {
    if (RESERVED_PROPERTIES.includes(name)) {
      console.warn("`".concat(name, "` is a reserved property and will be ignored"));
      return true;
    }
  }

  function isInteractorClass(klass) {
    return typeof klass === 'function' && 'extend' in klass && 'assert' in klass.prototype && 'exec' in klass.prototype && 'then' in klass.prototype;
  }

  function isInteractorDescriptor(prop) {
    var proto = getPrototypeOf(prop);
    return (proto === Object.prototype || proto == null) && ('child' in prop || 'value' in prop || 'get' in prop || 'assert' in prop);
  }

  function wrapInteractorProperty(name, fn, getter) {
    return defineProperty({
      enumerable: true,
      configurable: true
    }, getter ? 'get' : 'value', named(name, function () {
      var top = m.get(this, 'top');
      var result = fn.apply(top ? this : m.new(this, 'top', true), arguments);
      var queue = m.get(result, 'queue');

      if (queue) {
        if (m.eq(this, result)) {
          result = m.new(result, 'top', top);
        } else {
          result = m.new(result, 'parent', this);
        }

        if (!m.get(result, 'top') && queue.length && !getter) {
          while (m.get(result, 'parent')) {
            result = m.get(result, 'parent').exec(result);
          }
        }
      }

      return result;
    }));
  }

  function defineInteractorProperty(proto, name, descr) {
    var assert = descr.assert,
        child = descr.child,
        get = descr.get,
        value = descr.value;

    if (get || value || typeof child === 'function') {
      defineProperty$1(proto, name, wrapInteractorProperty(name, get || value || child, !!get));
    } else if (child) {
      defineProperty$1(proto, name, wrapInteractorProperty(name, function () {
        return child;
      }, true));
    }

    if (assert !== false && (assert || get || value)) {
      m.set(proto.assert, 'assertions', defineProperty({}, name, assert || createAssert(name, get || value)));
    } else if (child) {
      m.set(proto.assert, 'children', defineProperty({}, name, child));
    }

    return proto;
  }

  function defineInteractorProperties(proto, properties) {
    var _getOwnPropertyDescri = getOwnPropertyDescriptors(properties),
        assert = _getOwnPropertyDescri.assert,
        descriptors = objectWithoutProperties(_getOwnPropertyDescri, ["assert"]);

    if (assert) {
      m.set(proto.assert, 'assertions', map(assert.value, function (p, k) {
        return reserved(k) ? null : p;
      }));
    }

    var _iterator = _createForOfIteratorHelper(entries(descriptors)),
        _step;

    try {
      var _loop = function _loop() {
        var _properties$assert;

        var _step$value = slicedToArray(_step.value, 2),
            key = _step$value[0],
            _step$value$ = _step$value[1],
            get = _step$value$.get,
            value = _step$value$.value;

        if (reserved(key)) return "continue";
        var property = void 0;

        if (get) {
          property = {
            get: get
          };
        } else if (isInteractorClass(value)) {
          property = {
            child: function child(s) {
              return value(s);
            }
          };
        } else if (typeof value === 'function') {
          property = {
            value: value,
            assert: false
          };
        } else if (m.get(value, 'queue')) {
          property = {
            child: value
          };
        } else if (isInteractorDescriptor(value)) {
          property = value;
        }

        if (property && ((_properties$assert = properties.assert) === null || _properties$assert === void 0 ? void 0 : _properties$assert[key])) {
          property.assert = false;
        }

        if (property) {
          defineInteractorProperty(proto, key, property);
        }
      };

      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _ret = _loop();

        if (_ret === "continue") continue;
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    return proto;
  }
  function extend() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var properties = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : options;
    if (options === properties) options = null;
    var Parent = this;

    function Extended(selector, props) {
      if (props) {
        return Extended.extend(props)(selector);
      } else if (!(this instanceof Extended)) {
        return new Extended(selector);
      }

      Parent.call(this, selector);
    }
    defineProperties(Extended, assign(getOwnPropertyDescriptors(Parent), {
      prototype: {
        value: create(Parent.prototype, {
          constructor: {
            value: Extended
          },
          assert: {
            value: m.set(function () {
              return Parent.prototype.assert.apply(this, arguments);
            }, m.get(Parent.prototype.assert))
          }
        })
      }
    }));
    assign(Extended, options);
    defineInteractorProperties(Extended.prototype, properties);
    return Extended;
  }

  function dom(inst) {
    return inst.constructor.dom;
  }
  function hasLayoutEngine(inst, subj) {
    var suppressLayoutEngineWarning = m.top(inst).constructor.suppressLayoutEngineWarning;
    var result = hasLayoutEngine.result,
        debounce = hasLayoutEngine.debounce;

    if (result == null) {
      var _debounce;

      result = hasLayoutEngine.result = !dom(inst).navigator.userAgent.includes('jsdom');
      debounce = hasLayoutEngine.debounce = (_debounce = debounce) !== null && _debounce !== void 0 ? _debounce : {};
    }

    if (!suppressLayoutEngineWarning && !result) {
      if (!debounce[subj]) {
        console.warn("No layout engine detected. ".concat(subj, " as a result of CSS cannot be determined. ") + 'You can disable this warning by setting `I.suppressLayoutEngineWarning = true`');
      }

      clearTimeout(debounce[subj]);
      debounce[subj] = setTimeout(function () {
        return debounce[subj] = null;
      }, 100);
    }

    return result;
  }

  function getParentElement(inst, deep) {
    var _m$get = m.get(inst),
        parent = _m$get.parent,
        selector = _m$get.selector,
        nested = _m$get.nested;

    var $parent = nested && parent ? parent.$() : dom(inst).document.body;
    var ret = typeof selector === 'function' ? selector($parent) : selector ? $parent.querySelector(selector) : $parent;

    if (!ret) {
      throw InteractorError('could not find %{@}').bind(inst);
    }

    if (deep && 'contentDocument' in ret) {
      if (!ret.contentDocument) {
        throw InteractorError('%{@} is inaccessible, possibly due to CORS').bind(inst);
      } else {
        ret = ret.contentDocument.body;
      }
    }

    return ret;
  }

  function query(sel, multiple) {
    if (multiple && !sel) {
      throw InteractorError('cannot query for multiple elements without a selector');
    }

    var sq = m.get(sel, 'queue');

    if (sq === null || sq === void 0 ? void 0 : sq.length) {
      throw InteractorError('the provided interactor must not have queued actions');
    }

    var ret = getParentElement(this, !!sel);
    sel = sq ? m.get(sel, 'selector') : sel;

    if (sel) {
      if (typeof sel === 'function') {
        ret = sel(ret, multiple);
      } else if (typeof sel === 'string') {
        ret = multiple ? ret.querySelectorAll(sel) : ret.querySelector(sel);
      } else {
        throw InteractorError("unknown selector: ".concat(sel));
      }
    }

    ret = multiple ? Array.from(ret) : ret;

    if (!multiple && !ret) {
      throw InteractorError("could not find %{@ ".concat(sel, "}")).bind(this);
    }

    return ret;
  }
  function dispatch($el, name, _ref) {
    var _ref$bubbles = _ref.bubbles,
        bubbles = _ref$bubbles === void 0 ? true : _ref$bubbles,
        _ref$cancelable = _ref.cancelable,
        cancelable = _ref$cancelable === void 0 ? true : _ref$cancelable,
        options = objectWithoutProperties(_ref, ["bubbles", "cancelable"]);

    return $el.dispatchEvent(assign(new Event(name, {
      bubbles: bubbles,
      cancelable: cancelable
    }), options));
  }

  function blur() {
    return this.assert.focused().exec(function ($element) {
      return $element.blur();
    });
  }

  function isCheckboxOrRadio($el) {
    if ($el.type !== 'checkbox' && $el.type !== 'radio') {
      throw InteractorError('%{@} is not a checkbox or radio button');
    }
  }

  function check() {
    return this.assert(isCheckboxOrRadio).assert.not.disabled().assert.not.checked().exec(function ($el) {
      return $el.click();
    });
  }

  function click() {
    return this.assert.not.disabled().exec(function ($element) {
      return $element.click();
    });
  }

  function exec($element) {
    var win = $element.ownerDocument.defaultView;
    var document = win.document,
        self = win.self,
        top = win.top,
        frameElement = win.frameElement;

    if (frameElement && !document.hasFocus() && self !== top) {
      frameElement.focus();
    }

    if (!document.hasFocus()) {
      throw InteractorError('the document is not focusable');
    }

    $element.focus();
  }
  function focus() {
    return this.assert.focusable().exec(exec);
  }

  var k = {
    def: function def(key) {
      var def = DEFINITIONS[key];
      if (!def) throw InteractorError("unknown key `".concat(key, "`"));
      return def;
    },
    press: function press(key, active, next) {
      return m.new(next, 'keyboard', defineProperty({}, k.def(key).code, active));
    },
    parse: function parse(inst, key) {
      var pressed = m.get(m.top(inst, true), 'keyboard');
      var def = k.def(key);

      var _entries$reduce = entries(pressed).reduce(function (m, _ref) {
        var _ref2 = slicedToArray(_ref, 2),
            c = _ref2[0],
            v = _ref2[1];

        return assign(m, defineProperty({}, DEFINITIONS[c].key, v || null));
      }, {}),
          _entries$reduce$Alt = _entries$reduce.Alt,
          altKey = _entries$reduce$Alt === void 0 ? def.key === 'Alt' || false : _entries$reduce$Alt,
          _entries$reduce$Contr = _entries$reduce.Control,
          ctrlKey = _entries$reduce$Contr === void 0 ? def.key === 'Control' || false : _entries$reduce$Contr,
          _entries$reduce$Meta = _entries$reduce.Meta,
          metaKey = _entries$reduce$Meta === void 0 ? def.key === 'Meta' || false : _entries$reduce$Meta,
          _entries$reduce$Shift = _entries$reduce.Shift,
          shiftKey = _entries$reduce$Shift === void 0 ? def.key === 'Shift' || false : _entries$reduce$Shift;

      var event = {
        code: def.code,
        location: def.location || 0,
        repeat: pressed[def.code] || false,
        key: shiftKey && def.shiftKey || def.key,
        keyCode: shiftKey && def.shiftKeyCode || def.keyCode,
        altKey: altKey,
        ctrlKey: ctrlKey,
        metaKey: metaKey,
        shiftKey: shiftKey
      };
      var text = !(altKey || ctrlKey || metaKey) && (event.key.length === 1 ? event.key : def.text) || '';
      return {
        text: text,
        event: event
      };
    }
  };
  var DEFINITIONS = {
    '0': {
      keyCode: 48,
      key: '0',
      code: 'Digit0'
    },
    '1': {
      keyCode: 49,
      key: '1',
      code: 'Digit1'
    },
    '2': {
      keyCode: 50,
      key: '2',
      code: 'Digit2'
    },
    '3': {
      keyCode: 51,
      key: '3',
      code: 'Digit3'
    },
    '4': {
      keyCode: 52,
      key: '4',
      code: 'Digit4'
    },
    '5': {
      keyCode: 53,
      key: '5',
      code: 'Digit5'
    },
    '6': {
      keyCode: 54,
      key: '6',
      code: 'Digit6'
    },
    '7': {
      keyCode: 55,
      key: '7',
      code: 'Digit7'
    },
    '8': {
      keyCode: 56,
      key: '8',
      code: 'Digit8'
    },
    '9': {
      keyCode: 57,
      key: '9',
      code: 'Digit9'
    },
    'Power': {
      key: 'Power',
      code: 'Power'
    },
    'Eject': {
      key: 'Eject',
      code: 'Eject'
    },
    'Abort': {
      keyCode: 3,
      code: 'Abort',
      key: 'Cancel'
    },
    'Help': {
      keyCode: 6,
      code: 'Help',
      key: 'Help'
    },
    'Backspace': {
      keyCode: 8,
      code: 'Backspace',
      key: 'Backspace'
    },
    'Tab': {
      keyCode: 9,
      code: 'Tab',
      key: 'Tab'
    },
    'Numpad5': {
      keyCode: 12,
      shiftKeyCode: 101,
      key: 'Clear',
      code: 'Numpad5',
      shiftKey: '5',
      location: 3
    },
    'NumpadEnter': {
      keyCode: 13,
      code: 'NumpadEnter',
      key: 'Enter',
      text: '\r',
      location: 3
    },
    'Enter': {
      keyCode: 13,
      code: 'Enter',
      key: 'Enter',
      text: '\r'
    },
    '\r': {
      keyCode: 13,
      code: 'Enter',
      key: 'Enter',
      text: '\r'
    },
    '\n': {
      keyCode: 13,
      code: 'Enter',
      key: 'Enter',
      text: '\r'
    },
    'ShiftLeft': {
      keyCode: 16,
      code: 'ShiftLeft',
      key: 'Shift',
      location: 1
    },
    'ShiftRight': {
      keyCode: 16,
      code: 'ShiftRight',
      key: 'Shift',
      location: 2
    },
    'ControlLeft': {
      keyCode: 17,
      code: 'ControlLeft',
      key: 'Control',
      location: 1
    },
    'ControlRight': {
      keyCode: 17,
      code: 'ControlRight',
      key: 'Control',
      location: 2
    },
    'AltLeft': {
      keyCode: 18,
      code: 'AltLeft',
      key: 'Alt',
      location: 1
    },
    'AltRight': {
      keyCode: 18,
      code: 'AltRight',
      key: 'Alt',
      location: 2
    },
    'Pause': {
      keyCode: 19,
      code: 'Pause',
      key: 'Pause'
    },
    'CapsLock': {
      keyCode: 20,
      code: 'CapsLock',
      key: 'CapsLock'
    },
    'Escape': {
      keyCode: 27,
      code: 'Escape',
      key: 'Escape'
    },
    'Convert': {
      keyCode: 28,
      code: 'Convert',
      key: 'Convert'
    },
    'NonConvert': {
      keyCode: 29,
      code: 'NonConvert',
      key: 'NonConvert'
    },
    'Space': {
      keyCode: 32,
      code: 'Space',
      key: ' '
    },
    'Numpad9': {
      keyCode: 33,
      shiftKeyCode: 105,
      key: 'PageUp',
      code: 'Numpad9',
      shiftKey: '9',
      location: 3
    },
    'PageUp': {
      keyCode: 33,
      code: 'PageUp',
      key: 'PageUp'
    },
    'Numpad3': {
      keyCode: 34,
      shiftKeyCode: 99,
      key: 'PageDown',
      code: 'Numpad3',
      shiftKey: '3',
      location: 3
    },
    'PageDown': {
      keyCode: 34,
      code: 'PageDown',
      key: 'PageDown'
    },
    'End': {
      keyCode: 35,
      code: 'End',
      key: 'End'
    },
    'Numpad1': {
      keyCode: 35,
      shiftKeyCode: 97,
      key: 'End',
      code: 'Numpad1',
      shiftKey: '1',
      location: 3
    },
    'Home': {
      keyCode: 36,
      code: 'Home',
      key: 'Home'
    },
    'Numpad7': {
      keyCode: 36,
      shiftKeyCode: 103,
      key: 'Home',
      code: 'Numpad7',
      shiftKey: '7',
      location: 3
    },
    'ArrowLeft': {
      keyCode: 37,
      code: 'ArrowLeft',
      key: 'ArrowLeft'
    },
    'Numpad4': {
      keyCode: 37,
      shiftKeyCode: 100,
      key: 'ArrowLeft',
      code: 'Numpad4',
      shiftKey: '4',
      location: 3
    },
    'Numpad8': {
      keyCode: 38,
      shiftKeyCode: 104,
      key: 'ArrowUp',
      code: 'Numpad8',
      shiftKey: '8',
      location: 3
    },
    'ArrowUp': {
      keyCode: 38,
      code: 'ArrowUp',
      key: 'ArrowUp'
    },
    'ArrowRight': {
      keyCode: 39,
      code: 'ArrowRight',
      key: 'ArrowRight'
    },
    'Numpad6': {
      keyCode: 39,
      shiftKeyCode: 102,
      key: 'ArrowRight',
      code: 'Numpad6',
      shiftKey: '6',
      location: 3
    },
    'Numpad2': {
      keyCode: 40,
      shiftKeyCode: 98,
      key: 'ArrowDown',
      code: 'Numpad2',
      shiftKey: '2',
      location: 3
    },
    'ArrowDown': {
      keyCode: 40,
      code: 'ArrowDown',
      key: 'ArrowDown'
    },
    'Select': {
      keyCode: 41,
      code: 'Select',
      key: 'Select'
    },
    'Open': {
      keyCode: 43,
      code: 'Open',
      key: 'Execute'
    },
    'PrintScreen': {
      keyCode: 44,
      code: 'PrintScreen',
      key: 'PrintScreen'
    },
    'Insert': {
      keyCode: 45,
      code: 'Insert',
      key: 'Insert'
    },
    'Numpad0': {
      keyCode: 45,
      shiftKeyCode: 96,
      key: 'Insert',
      code: 'Numpad0',
      shiftKey: '0',
      location: 3
    },
    'Delete': {
      keyCode: 46,
      code: 'Delete',
      key: 'Delete'
    },
    'NumpadDecimal': {
      keyCode: 46,
      shiftKeyCode: 110,
      code: 'NumpadDecimal',
      key: "\0",
      shiftKey: '.',
      location: 3
    },
    'Digit0': {
      keyCode: 48,
      code: 'Digit0',
      shiftKey: ')',
      key: '0'
    },
    'Digit1': {
      keyCode: 49,
      code: 'Digit1',
      shiftKey: '!',
      key: '1'
    },
    'Digit2': {
      keyCode: 50,
      code: 'Digit2',
      shiftKey: '@',
      key: '2'
    },
    'Digit3': {
      keyCode: 51,
      code: 'Digit3',
      shiftKey: '#',
      key: '3'
    },
    'Digit4': {
      keyCode: 52,
      code: 'Digit4',
      shiftKey: '$',
      key: '4'
    },
    'Digit5': {
      keyCode: 53,
      code: 'Digit5',
      shiftKey: '%',
      key: '5'
    },
    'Digit6': {
      keyCode: 54,
      code: 'Digit6',
      shiftKey: '^',
      key: '6'
    },
    'Digit7': {
      keyCode: 55,
      code: 'Digit7',
      shiftKey: '&',
      key: '7'
    },
    'Digit8': {
      keyCode: 56,
      code: 'Digit8',
      shiftKey: '*',
      key: '8'
    },
    'Digit9': {
      keyCode: 57,
      code: 'Digit9',
      shiftKey: '(',
      key: '9'
    },
    'KeyA': {
      keyCode: 65,
      code: 'KeyA',
      shiftKey: 'A',
      key: 'a'
    },
    'KeyB': {
      keyCode: 66,
      code: 'KeyB',
      shiftKey: 'B',
      key: 'b'
    },
    'KeyC': {
      keyCode: 67,
      code: 'KeyC',
      shiftKey: 'C',
      key: 'c'
    },
    'KeyD': {
      keyCode: 68,
      code: 'KeyD',
      shiftKey: 'D',
      key: 'd'
    },
    'KeyE': {
      keyCode: 69,
      code: 'KeyE',
      shiftKey: 'E',
      key: 'e'
    },
    'KeyF': {
      keyCode: 70,
      code: 'KeyF',
      shiftKey: 'F',
      key: 'f'
    },
    'KeyG': {
      keyCode: 71,
      code: 'KeyG',
      shiftKey: 'G',
      key: 'g'
    },
    'KeyH': {
      keyCode: 72,
      code: 'KeyH',
      shiftKey: 'H',
      key: 'h'
    },
    'KeyI': {
      keyCode: 73,
      code: 'KeyI',
      shiftKey: 'I',
      key: 'i'
    },
    'KeyJ': {
      keyCode: 74,
      code: 'KeyJ',
      shiftKey: 'J',
      key: 'j'
    },
    'KeyK': {
      keyCode: 75,
      code: 'KeyK',
      shiftKey: 'K',
      key: 'k'
    },
    'KeyL': {
      keyCode: 76,
      code: 'KeyL',
      shiftKey: 'L',
      key: 'l'
    },
    'KeyM': {
      keyCode: 77,
      code: 'KeyM',
      shiftKey: 'M',
      key: 'm'
    },
    'KeyN': {
      keyCode: 78,
      code: 'KeyN',
      shiftKey: 'N',
      key: 'n'
    },
    'KeyO': {
      keyCode: 79,
      code: 'KeyO',
      shiftKey: 'O',
      key: 'o'
    },
    'KeyP': {
      keyCode: 80,
      code: 'KeyP',
      shiftKey: 'P',
      key: 'p'
    },
    'KeyQ': {
      keyCode: 81,
      code: 'KeyQ',
      shiftKey: 'Q',
      key: 'q'
    },
    'KeyR': {
      keyCode: 82,
      code: 'KeyR',
      shiftKey: 'R',
      key: 'r'
    },
    'KeyS': {
      keyCode: 83,
      code: 'KeyS',
      shiftKey: 'S',
      key: 's'
    },
    'KeyT': {
      keyCode: 84,
      code: 'KeyT',
      shiftKey: 'T',
      key: 't'
    },
    'KeyU': {
      keyCode: 85,
      code: 'KeyU',
      shiftKey: 'U',
      key: 'u'
    },
    'KeyV': {
      keyCode: 86,
      code: 'KeyV',
      shiftKey: 'V',
      key: 'v'
    },
    'KeyW': {
      keyCode: 87,
      code: 'KeyW',
      shiftKey: 'W',
      key: 'w'
    },
    'KeyX': {
      keyCode: 88,
      code: 'KeyX',
      shiftKey: 'X',
      key: 'x'
    },
    'KeyY': {
      keyCode: 89,
      code: 'KeyY',
      shiftKey: 'Y',
      key: 'y'
    },
    'KeyZ': {
      keyCode: 90,
      code: 'KeyZ',
      shiftKey: 'Z',
      key: 'z'
    },
    'MetaLeft': {
      keyCode: 91,
      code: 'MetaLeft',
      key: 'Meta',
      location: 1
    },
    'MetaRight': {
      keyCode: 92,
      code: 'MetaRight',
      key: 'Meta',
      location: 2
    },
    'ContextMenu': {
      keyCode: 93,
      code: 'ContextMenu',
      key: 'ContextMenu'
    },
    'NumpadMultiply': {
      keyCode: 106,
      code: 'NumpadMultiply',
      key: '*',
      location: 3
    },
    'NumpadAdd': {
      keyCode: 107,
      code: 'NumpadAdd',
      key: '+',
      location: 3
    },
    'NumpadSubtract': {
      keyCode: 109,
      code: 'NumpadSubtract',
      key: '-',
      location: 3
    },
    'NumpadDivide': {
      keyCode: 111,
      code: 'NumpadDivide',
      key: '/',
      location: 3
    },
    'F1': {
      keyCode: 112,
      code: 'F1',
      key: 'F1'
    },
    'F2': {
      keyCode: 113,
      code: 'F2',
      key: 'F2'
    },
    'F3': {
      keyCode: 114,
      code: 'F3',
      key: 'F3'
    },
    'F4': {
      keyCode: 115,
      code: 'F4',
      key: 'F4'
    },
    'F5': {
      keyCode: 116,
      code: 'F5',
      key: 'F5'
    },
    'F6': {
      keyCode: 117,
      code: 'F6',
      key: 'F6'
    },
    'F7': {
      keyCode: 118,
      code: 'F7',
      key: 'F7'
    },
    'F8': {
      keyCode: 119,
      code: 'F8',
      key: 'F8'
    },
    'F9': {
      keyCode: 120,
      code: 'F9',
      key: 'F9'
    },
    'F10': {
      keyCode: 121,
      code: 'F10',
      key: 'F10'
    },
    'F11': {
      keyCode: 122,
      code: 'F11',
      key: 'F11'
    },
    'F12': {
      keyCode: 123,
      code: 'F12',
      key: 'F12'
    },
    'F13': {
      keyCode: 124,
      code: 'F13',
      key: 'F13'
    },
    'F14': {
      keyCode: 125,
      code: 'F14',
      key: 'F14'
    },
    'F15': {
      keyCode: 126,
      code: 'F15',
      key: 'F15'
    },
    'F16': {
      keyCode: 127,
      code: 'F16',
      key: 'F16'
    },
    'F17': {
      keyCode: 128,
      code: 'F17',
      key: 'F17'
    },
    'F18': {
      keyCode: 129,
      code: 'F18',
      key: 'F18'
    },
    'F19': {
      keyCode: 130,
      code: 'F19',
      key: 'F19'
    },
    'F20': {
      keyCode: 131,
      code: 'F20',
      key: 'F20'
    },
    'F21': {
      keyCode: 132,
      code: 'F21',
      key: 'F21'
    },
    'F22': {
      keyCode: 133,
      code: 'F22',
      key: 'F22'
    },
    'F23': {
      keyCode: 134,
      code: 'F23',
      key: 'F23'
    },
    'F24': {
      keyCode: 135,
      code: 'F24',
      key: 'F24'
    },
    'NumLock': {
      keyCode: 144,
      code: 'NumLock',
      key: 'NumLock'
    },
    'ScrollLock': {
      keyCode: 145,
      code: 'ScrollLock',
      key: 'ScrollLock'
    },
    'AudioVolumeMute': {
      keyCode: 173,
      code: 'AudioVolumeMute',
      key: 'AudioVolumeMute'
    },
    'AudioVolumeDown': {
      keyCode: 174,
      code: 'AudioVolumeDown',
      key: 'AudioVolumeDown'
    },
    'AudioVolumeUp': {
      keyCode: 175,
      code: 'AudioVolumeUp',
      key: 'AudioVolumeUp'
    },
    'MediaTrackNext': {
      keyCode: 176,
      code: 'MediaTrackNext',
      key: 'MediaTrackNext'
    },
    'MediaTrackPrevious': {
      keyCode: 177,
      code: 'MediaTrackPrevious',
      key: 'MediaTrackPrevious'
    },
    'MediaStop': {
      keyCode: 178,
      code: 'MediaStop',
      key: 'MediaStop'
    },
    'MediaPlayPause': {
      keyCode: 179,
      code: 'MediaPlayPause',
      key: 'MediaPlayPause'
    },
    'Semicolon': {
      keyCode: 186,
      code: 'Semicolon',
      shiftKey: ':',
      key: ';'
    },
    'Equal': {
      keyCode: 187,
      code: 'Equal',
      shiftKey: '+',
      key: '='
    },
    'NumpadEqual': {
      keyCode: 187,
      code: 'NumpadEqual',
      key: '=',
      location: 3
    },
    'Comma': {
      keyCode: 188,
      code: 'Comma',
      shiftKey: '<',
      key: ','
    },
    'Minus': {
      keyCode: 189,
      code: 'Minus',
      shiftKey: '_',
      key: '-'
    },
    'Period': {
      keyCode: 190,
      code: 'Period',
      shiftKey: '>',
      key: '.'
    },
    'Slash': {
      keyCode: 191,
      code: 'Slash',
      shiftKey: '?',
      key: '/'
    },
    'Backquote': {
      keyCode: 192,
      code: 'Backquote',
      shiftKey: '~',
      key: '`'
    },
    'BracketLeft': {
      keyCode: 219,
      code: 'BracketLeft',
      shiftKey: '{ ',
      key: '['
    },
    'Backslash': {
      keyCode: 220,
      code: 'Backslash',
      shiftKey: '|',
      key: '\\'
    },
    'BracketRight': {
      keyCode: 221,
      code: 'BracketRight',
      shiftKey: ' }',
      key: ']'
    },
    'Quote': {
      keyCode: 222,
      code: 'Quote',
      shiftKey: '"',
      key: '\''
    },
    'AltGraph': {
      keyCode: 225,
      code: 'AltGraph',
      key: 'AltGraph'
    },
    'Props': {
      keyCode: 247,
      code: 'Props',
      key: 'CrSel'
    },
    'Cancel': {
      keyCode: 3,
      key: 'Cancel',
      code: 'Abort'
    },
    'Clear': {
      keyCode: 12,
      key: 'Clear',
      code: 'Numpad5',
      location: 3
    },
    'Shift': {
      keyCode: 16,
      key: 'Shift',
      code: 'ShiftLeft',
      location: 1
    },
    'Control': {
      keyCode: 17,
      key: 'Control',
      code: 'ControlLeft',
      location: 1
    },
    'Alt': {
      keyCode: 18,
      key: 'Alt',
      code: 'AltLeft',
      location: 1
    },
    'Accept': {
      keyCode: 30,
      key: 'Accept'
    },
    'ModeChange': {
      keyCode: 31,
      key: 'ModeChange'
    },
    ' ': {
      keyCode: 32,
      key: ' ',
      code: 'Space'
    },
    'Print': {
      keyCode: 42,
      key: 'Print'
    },
    'Execute': {
      keyCode: 43,
      key: 'Execute',
      code: 'Open'
    },
    "\0": {
      keyCode: 46,
      key: "\0",
      code: 'NumpadDecimal',
      location: 3
    },
    'a': {
      keyCode: 65,
      key: 'a',
      code: 'KeyA'
    },
    'b': {
      keyCode: 66,
      key: 'b',
      code: 'KeyB'
    },
    'c': {
      keyCode: 67,
      key: 'c',
      code: 'KeyC'
    },
    'd': {
      keyCode: 68,
      key: 'd',
      code: 'KeyD'
    },
    'e': {
      keyCode: 69,
      key: 'e',
      code: 'KeyE'
    },
    'f': {
      keyCode: 70,
      key: 'f',
      code: 'KeyF'
    },
    'g': {
      keyCode: 71,
      key: 'g',
      code: 'KeyG'
    },
    'h': {
      keyCode: 72,
      key: 'h',
      code: 'KeyH'
    },
    'i': {
      keyCode: 73,
      key: 'i',
      code: 'KeyI'
    },
    'j': {
      keyCode: 74,
      key: 'j',
      code: 'KeyJ'
    },
    'k': {
      keyCode: 75,
      key: 'k',
      code: 'KeyK'
    },
    'l': {
      keyCode: 76,
      key: 'l',
      code: 'KeyL'
    },
    'm': {
      keyCode: 77,
      key: 'm',
      code: 'KeyM'
    },
    'n': {
      keyCode: 78,
      key: 'n',
      code: 'KeyN'
    },
    'o': {
      keyCode: 79,
      key: 'o',
      code: 'KeyO'
    },
    'p': {
      keyCode: 80,
      key: 'p',
      code: 'KeyP'
    },
    'q': {
      keyCode: 81,
      key: 'q',
      code: 'KeyQ'
    },
    'r': {
      keyCode: 82,
      key: 'r',
      code: 'KeyR'
    },
    's': {
      keyCode: 83,
      key: 's',
      code: 'KeyS'
    },
    't': {
      keyCode: 84,
      key: 't',
      code: 'KeyT'
    },
    'u': {
      keyCode: 85,
      key: 'u',
      code: 'KeyU'
    },
    'v': {
      keyCode: 86,
      key: 'v',
      code: 'KeyV'
    },
    'w': {
      keyCode: 87,
      key: 'w',
      code: 'KeyW'
    },
    'x': {
      keyCode: 88,
      key: 'x',
      code: 'KeyX'
    },
    'y': {
      keyCode: 89,
      key: 'y',
      code: 'KeyY'
    },
    'z': {
      keyCode: 90,
      key: 'z',
      code: 'KeyZ'
    },
    'Meta': {
      keyCode: 91,
      key: 'Meta',
      code: 'MetaLeft',
      location: 1
    },
    '*': {
      keyCode: 106,
      key: '*',
      code: 'NumpadMultiply',
      location: 3
    },
    '+': {
      keyCode: 107,
      key: '+',
      code: 'NumpadAdd',
      location: 3
    },
    '-': {
      keyCode: 109,
      key: '-',
      code: 'NumpadSubtract',
      location: 3
    },
    '/': {
      keyCode: 111,
      key: '/',
      code: 'NumpadDivide',
      location: 3
    },
    ';': {
      keyCode: 186,
      key: ';',
      code: 'Semicolon'
    },
    '=': {
      keyCode: 187,
      key: '=',
      code: 'Equal'
    },
    ',': {
      keyCode: 188,
      key: ',',
      code: 'Comma'
    },
    '.': {
      keyCode: 190,
      key: '.',
      code: 'Period'
    },
    '`': {
      keyCode: 192,
      key: '`',
      code: 'Backquote'
    },
    '[': {
      keyCode: 219,
      key: '[',
      code: 'BracketLeft'
    },
    '\\': {
      keyCode: 220,
      key: '\\',
      code: 'Backslash'
    },
    ']': {
      keyCode: 221,
      key: ']',
      code: 'BracketRight'
    },
    '\'': {
      keyCode: 222,
      key: '\'',
      code: 'Quote'
    },
    'Attn': {
      keyCode: 246,
      key: 'Attn'
    },
    'CrSel': {
      keyCode: 247,
      key: 'CrSel',
      code: 'Props'
    },
    'ExSel': {
      keyCode: 248,
      key: 'ExSel'
    },
    'EraseEof': {
      keyCode: 249,
      key: 'EraseEof'
    },
    'Play': {
      keyCode: 250,
      key: 'Play'
    },
    'ZoomOut': {
      keyCode: 251,
      key: 'ZoomOut'
    },
    ')': {
      keyCode: 48,
      key: ')',
      code: 'Digit0'
    },
    '!': {
      keyCode: 49,
      key: '!',
      code: 'Digit1'
    },
    '@': {
      keyCode: 50,
      key: '@',
      code: 'Digit2'
    },
    '#': {
      keyCode: 51,
      key: '#',
      code: 'Digit3'
    },
    '$': {
      keyCode: 52,
      key: '$',
      code: 'Digit4'
    },
    '%': {
      keyCode: 53,
      key: '%',
      code: 'Digit5'
    },
    '^': {
      keyCode: 54,
      key: '^',
      code: 'Digit6'
    },
    '&': {
      keyCode: 55,
      key: '&',
      code: 'Digit7'
    },
    '(': {
      keyCode: 57,
      key: '(',
      code: 'Digit9'
    },
    'A': {
      keyCode: 65,
      key: 'A',
      code: 'KeyA'
    },
    'B': {
      keyCode: 66,
      key: 'B',
      code: 'KeyB'
    },
    'C': {
      keyCode: 67,
      key: 'C',
      code: 'KeyC'
    },
    'D': {
      keyCode: 68,
      key: 'D',
      code: 'KeyD'
    },
    'E': {
      keyCode: 69,
      key: 'E',
      code: 'KeyE'
    },
    'F': {
      keyCode: 70,
      key: 'F',
      code: 'KeyF'
    },
    'G': {
      keyCode: 71,
      key: 'G',
      code: 'KeyG'
    },
    'H': {
      keyCode: 72,
      key: 'H',
      code: 'KeyH'
    },
    'I': {
      keyCode: 73,
      key: 'I',
      code: 'KeyI'
    },
    'J': {
      keyCode: 74,
      key: 'J',
      code: 'KeyJ'
    },
    'K': {
      keyCode: 75,
      key: 'K',
      code: 'KeyK'
    },
    'L': {
      keyCode: 76,
      key: 'L',
      code: 'KeyL'
    },
    'M': {
      keyCode: 77,
      key: 'M',
      code: 'KeyM'
    },
    'N': {
      keyCode: 78,
      key: 'N',
      code: 'KeyN'
    },
    'O': {
      keyCode: 79,
      key: 'O',
      code: 'KeyO'
    },
    'P': {
      keyCode: 80,
      key: 'P',
      code: 'KeyP'
    },
    'Q': {
      keyCode: 81,
      key: 'Q',
      code: 'KeyQ'
    },
    'R': {
      keyCode: 82,
      key: 'R',
      code: 'KeyR'
    },
    'S': {
      keyCode: 83,
      key: 'S',
      code: 'KeyS'
    },
    'T': {
      keyCode: 84,
      key: 'T',
      code: 'KeyT'
    },
    'U': {
      keyCode: 85,
      key: 'U',
      code: 'KeyU'
    },
    'V': {
      keyCode: 86,
      key: 'V',
      code: 'KeyV'
    },
    'W': {
      keyCode: 87,
      key: 'W',
      code: 'KeyW'
    },
    'X': {
      keyCode: 88,
      key: 'X',
      code: 'KeyX'
    },
    'Y': {
      keyCode: 89,
      key: 'Y',
      code: 'KeyY'
    },
    'Z': {
      keyCode: 90,
      key: 'Z',
      code: 'KeyZ'
    },
    ':': {
      keyCode: 186,
      key: ':',
      code: 'Semicolon'
    },
    '<': {
      keyCode: 188,
      key: '<',
      code: 'Comma'
    },
    '_': {
      keyCode: 189,
      key: '_',
      code: 'Minus'
    },
    '>': {
      keyCode: 190,
      key: '>',
      code: 'Period'
    },
    '?': {
      keyCode: 191,
      key: '?',
      code: 'Slash'
    },
    '~': {
      keyCode: 192,
      key: '~',
      code: 'Backquote'
    },
    '{': {
      keyCode: 219,
      key: '{',
      code: 'BracketLeft'
    },
    '|': {
      keyCode: 220,
      key: '|',
      code: 'Backslash'
    },
    '}': {
      keyCode: 221,
      key: '}',
      code: 'BracketRight'
    },
    '"': {
      keyCode: 222,
      key: '"',
      code: 'Quote'
    }
  };

  function getTextRange($element) {
    var win = $element.ownerDocument.defaultView;
    var sel = win.getSelection();
    var start, end;

    if ('selectionStart' in $element) {
      start = $element.selectionStart;
      end = $element.selectionEnd;
    } else if (sel.containsNode($element, true) || $element.contains(sel.anchorNode) || $element.contains(sel.focusNode)) {
      var range = sel.getRangeAt(0);
      var caretRange = range.cloneRange();
      caretRange.selectNodeContents($element);
      caretRange.setEnd(range.startContainer, range.startOffset);
      start = caretRange.toString().length;
      caretRange.setEnd(range.endContainer, range.endOffset);
      end = caretRange.toString().length;
    }

    if (start || end) {
      return [start, end];
    }
  }

  function exec$1($element, parsed, _ref) {
    var range = _ref.range,
        replace = _ref.replace;
    var char = parsed.text,
        event = parsed.event;
    var cancelled = !dispatch($element, 'keydown', event);
    if (cancelled || !(char || event.key === 'Backspace' || event.key === 'Delete')) return;
    var isInput = /^(input|textarea)$/i.test($element.tagName);
    if (!isInput && !$element.isContentEditable) return;
    var descr = isInput && getOwnPropertyDescriptor($element, 'value');
    if (descr) delete $element.value;
    event = char ? assign({
      charCode: char.charCodeAt(0)
    }, event) : event;
    cancelled = !dispatch($element, 'keypress', event) || !dispatch($element, 'beforeinput', event);

    if (!cancelled) {
      var value = isInput ? $element.value : $element.textContent;
      range = replace ? [0, value.length] : range;
      range = [].concat(range || getTextRange($element) || value.length);
      if (range.length === 1) range[1] = range[0];
      if (event.key === 'Backspace') range[0] -= 1;
      if (event.key === 'Delete') range[1] += 1;
      value = value.slice(0, range[0]) + char + value.slice(range[1]);

      if (isInput) {
        $element.value = value;
      } else {
        $element.textContent = value;
      }

      dispatch($element, 'input', assign({
        cancelable: false
      }, event));
    }

    if (descr) defineProperty$1($element, 'value', descr);
  }
  function keydown(key) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return k.press(key, true, this.assert.exists().exec(function ($element) {
      exec$1($element, k.parse(this, key), options);
    }));
  }

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
  function exec$2($element, _ref) {
    var event = _ref.event;
    dispatch($element, 'keyup', _objectSpread({
      cancelable: false
    }, event));
  }
  function keyup(key) {
    return k.press(key, false, this.assert.exists().exec(function ($element) {
      exec$2($element, k.parse(this, key));
    }));
  }

  function exec$3(_x, _x2, _x3) {
    return _exec.apply(this, arguments);
  }

  function _exec() {
    _exec = asyncToGenerator(regenerator.mark(function _callee2($element, parsed, _ref) {
      var range, replace, delay, i, l, ra, re;
      return regenerator.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              range = _ref.range, replace = _ref.replace, delay = _ref.delay;
              range = range != null && [].concat(range);
              i = 0, l = parsed.length;

            case 3:
              if (!(i < l)) {
                _context2.next = 14;
                break;
              }

              ra = range && (i === 0 ? range : range[0] + i);
              re = i === 0 && replace;
              exec$1($element, parsed[i], {
                range: ra,
                replace: re
              });
              exec$2($element, parsed[i]);

              if (!(delay && i !== l - 1)) {
                _context2.next = 11;
                break;
              }

              _context2.next = 11;
              return new Promise(function (r) {
                return setTimeout(r, delay);
              });

            case 11:
              i++;
              _context2.next = 3;
              break;

            case 14:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _exec.apply(this, arguments);
  }

  function press(keys) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return this.assert.exists().exec(function () {
      var _ref2 = asyncToGenerator(regenerator.mark(function _callee($element) {
        var _this = this;

        var parsed;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                parsed = [].concat(keys).map(function (c) {
                  return k.parse(_this, c);
                });
                _context.next = 3;
                return exec$3($element, parsed, options);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x4) {
        return _ref2.apply(this, arguments);
      };
    }());
  }

  function scroll() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var next = this;
    var _options$top = options.top,
        top = _options$top === void 0 ? options.y : _options$top,
        _options$left = options.left,
        left = _options$left === void 0 ? options.x : _options$left,
        _options$wheel = options.wheel,
        wheel = _options$wheel === void 0 ? false : _options$wheel,
        _options$frequency = options.frequency,
        frequency = _options$frequency === void 0 ? 1 : _options$frequency;

    if (top == null && left == null) {
      throw InteractorError('missing scroll direction');
    }

    if (left != null) {
      next = next.assert.scrollableX();
    }

    if (top != null) {
      next = next.assert.scrollableY();
    }

    return next.exec(function ($el) {
      for (var i = 1; i <= frequency; i++) {
        var cancelled = false;

        if (wheel) {
          cancelled = !dispatch($el, 'wheel', {});
        }

        if (!cancelled) {
          if (top) $el.scrollTop = top / frequency * i;
          if (left) $el.scrollLeft = left / frequency * i;
          dispatch($el, 'scroll', {
            cancelable: false
          });
        }
      }
    });
  }

  function options($el, selector, each) {
    var _this = this;

    var multi = Array.isArray(selector);

    if (!('options' in $el)) {
      throw InteractorError('%{@} is not a select element');
    } else if (multi && !$el.multiple) {
      throw InteractorError('%{@} is not a multi select element');
    }

    if ($el.multiple) {
      if (multi) {
        selector.map(function (s) {
          return each(_this.$(s), s);
        });
      } else {
        this.$$(selector).map(function ($o) {
          return each($o, selector);
        });
      }
    } else {
      each(this.$(selector), selector);
    }
  }

  function select(selector) {
    return this.assert.not.disabled().assert(function ($el) {
      options.call(this, $el, selector, function ($opt, sel) {
        if ($opt.disabled) {
          throw InteractorError("%{@ ".concat(sel, "} is disabled"));
        }
      });
    }).exec(function ($el) {
      options.call(this, $el, selector, function ($opt) {
        $opt.selected = $el.multiple ? !$opt.selected : true;
        dispatch($el, 'input', {
          cancelable: false
        });
        dispatch($el, 'change', {
          cancelable: false
        });
      });
    });
  }

  function trigger(event) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return this.assert.exists().exec(function ($el) {
      return dispatch($el, event, options);
    });
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return arrayLikeToArray(arr);
  }

  var arrayWithoutHoles = _arrayWithoutHoles;

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
  }

  var iterableToArray = _iterableToArray;

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var nonIterableSpread = _nonIterableSpread;

  function _toConsumableArray(arr) {
    return arrayWithoutHoles(arr) || iterableToArray(arr) || unsupportedIterableToArray(arr) || nonIterableSpread();
  }

  var toConsumableArray = _toConsumableArray;

  function get() {
    return this.$() === document.activeElement;
  }

  var focused = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get: get
  });

  function type(text) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        range = _ref.range,
        replace = _ref.replace,
        delay = _ref.delay,
        _ref$focus = _ref.focus,
        focus = _ref$focus === void 0 ? true : _ref$focus,
        _ref$blur = _ref.blur,
        blur = _ref$blur === void 0 ? true : _ref$blur,
        _ref$change = _ref.change,
        change = _ref$change === void 0 ? blur : _ref$change;

    return this.assert.focusable().exec(function () {
      var _ref2 = asyncToGenerator(regenerator.mark(function _callee($element) {
        var _this = this;

        var parsed;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (focus && !get.call(this)) {
                  exec($element);
                }

                parsed = toConsumableArray(text).map(function (c) {
                  return k.parse(_this, c);
                });
                _context.next = 4;
                return exec$3($element, parsed, {
                  range: range,
                  replace: replace,
                  delay: delay
                });

              case 4:
                if (change && /^(input|textarea)$/i.test($element.tagName)) {
                  dispatch($element, 'change', {
                    cancelable: false
                  });
                }

                if (blur && get.call(this)) {
                  $element.blur();
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }());
  }

  function isCheckboxNotRadio($el) {
    if ($el.type === 'radio') {
      throw InteractorError('%{@} is a radio button which cannot be unchecked');
    } else if ($el.type !== 'checkbox') {
      throw InteractorError('%{@} is not a checkbox');
    }
  }

  function uncheck() {
    return this.assert(isCheckboxNotRadio).assert.not.disabled().assert.checked().exec(function ($el) {
      return $el.click();
    });
  }

  var actions = /*#__PURE__*/Object.freeze({
    __proto__: null,
    blur: blur,
    check: check,
    click: click,
    focus: focus,
    keydown: keydown,
    keyup: keyup,
    press: press,
    scroll: scroll,
    select: select,
    trigger: trigger,
    type: type,
    uncheck: uncheck
  });

  function value(attr) {
    return this.$().getAttribute(attr);
  }

  var attribute = /*#__PURE__*/Object.freeze({
    __proto__: null,
    value: value
  });

  function get$1() {
    return !!this.$().checked;
  }

  var checked = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get: get$1
  });

  function newEmptyInteractor(inst) {
    var I, proto;

    while ((proto = getPrototypeOf(proto || inst)) !== Object.prototype) {
      I = proto.constructor;
    }

    return m.new(I(), 'selector', null);
  }

  function value$1() {
    var selector = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    var parent = selector && this;

    if (!parent) {
      var _m$get = m.get(this);

      parent = _m$get.parent;
      selector = _m$get.selector;
      parent = parent || newEmptyInteractor(this);
    }

    return parent.$$(selector).length;
  }
  var assert = assertion(function (selector) {
    var expected = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : selector;
    selector = expected !== selector ? selector : '';
    var actual = value$1.call(this, selector);
    return {
      message: "found ".concat(actual, " element").concat(actual === 1 ? '' : 's', " ") + "matching %{@ ".concat(selector, "} but expected %{- ").concat(expected, "|not to}"),
      result: actual === expected
    };
  });

  var count = /*#__PURE__*/Object.freeze({
    __proto__: null,
    value: value$1,
    assert: assert
  });

  function get$2() {
    return !!this.$().disabled;
  }

  var disabled = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get: get$2
  });

  function get$3() {
    try {
      return !!this.$();
    } catch (e) {
      return false;
    }
  }
  var assert$1 = assertion(get$3, function (result) {
    return {
      message: '%{@} %{- does not exist|exists}',
      result: result
    };
  });

  var exists = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get: get$3,
    assert: assert$1
  });

  function get$4() {
    return !this.disabled && !!(~this.$().tabIndex || this.$().isContentEditable);
  }
  function assert$2(expected) {
    var result = get$4.call(this);

    if (expected) {
      this.assert.not.disabled();
    }

    if (result !== expected) {
      throw InteractorError('%{@} is %{- not} focusable');
    }
  }

  var focusable = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get: get$4,
    assert: assert$2
  });

  function value$2(selector) {
    return this.$().matches(selector);
  }
  var assert$3 = assertion(value$2, function (result, selector) {
    return {
      message: "%{@} %{- does not match|matches} ".concat(selector, " ") + '%{- |but expected it not to}',
      result: result
    };
  });

  var matches = /*#__PURE__*/Object.freeze({
    __proto__: null,
    value: value$2,
    assert: assert$3
  });

  var LAYOUT_PROPS = ['scrollTop', 'scrollLeft', 'scrollWidth', 'scrollHeight', 'clientTop', 'clientLeft', 'clientWidth', 'clientHeight'];
  function value$3(prop) {
    if (LAYOUT_PROPS.includes(prop)) {
      hasLayoutEngine(this, 'Layout');
    }

    return this.$()[prop];
  }

  var property = /*#__PURE__*/Object.freeze({
    __proto__: null,
    value: value$3
  });

  function isScrollableX(inst, $el) {
    return hasLayoutEngine(inst, 'Overflow') && $el.scrollWidth > $el.clientWidth;
  }
  function get$5() {
    return isScrollableX(this, this.$());
  }
  var assert$4 = assertion(get$5, function (result) {
    return {
      message: '%{@} has %{- no} overflow-x',
      result: result
    };
  });

  var scrollableX = /*#__PURE__*/Object.freeze({
    __proto__: null,
    isScrollableX: isScrollableX,
    get: get$5,
    assert: assert$4
  });

  function isScrollableY(inst, $el) {
    return hasLayoutEngine(inst, 'Overflow') && $el.scrollHeight > $el.clientHeight;
  }
  function get$6() {
    return isScrollableY(this, this.$());
  }
  var assert$5 = assertion(get$6, function (result) {
    return {
      message: '%{@} has %{- no} overflow-y',
      result: result
    };
  });

  var scrollableY = /*#__PURE__*/Object.freeze({
    __proto__: null,
    isScrollableY: isScrollableY,
    get: get$6,
    assert: assert$5
  });

  function get$7() {
    var $el = this.$();
    return isScrollableY(this, $el) || isScrollableX(this, $el);
  }
  var assert$6 = assertion(get$7, function (result) {
    return {
      message: '%{@} has %{- no} overflow',
      result: result
    };
  });

  var scrollable = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get: get$7,
    assert: assert$6
  });

  function get$8() {
    return !!this.$().selected;
  }

  var selected = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get: get$8
  });

  function get$9() {
    return hasLayoutEngine(this, 'Text content') ? this.$().innerText : this.$().textContent;
  }

  var text = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get: get$9
  });

  function get$a() {
    return this.$().value;
  }

  var value$4 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get: get$a
  });

  var properties = /*#__PURE__*/Object.freeze({
    __proto__: null,
    attribute: attribute,
    checked: checked,
    count: count,
    disabled: disabled,
    exists: exists,
    focusable: focusable,
    focused: focused,
    matches: matches,
    property: property,
    scrollable: scrollable,
    scrollableX: scrollableX,
    scrollableY: scrollableY,
    selected: selected,
    text: text,
    value: value$4
  });

  function _createForOfIteratorHelper$1(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$2(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

  function _unsupportedIterableToArray$2(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$2(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$2(o, minLen); }

  function _arrayLikeToArray$2(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
  function xpath(path) {
    return assign(function ($node, multiple) {
      var result = document.evaluate(path, $node, null, multiple ? 5 : 9, null);
      var arr, n;

      if (multiple) {
        arr = [];

        while (n = result.iterateNext()) {
          arr.push(n);
        }

        return arr;
      }

      return result.singleNodeValue;
    }, {
      toString: function toString() {
        return "xpath(".concat(path, ")");
      }
    });
  }
  function text$1(string) {
    var selector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '*';
    return assign(function ($node, multiple) {
      var result;

      var _iterator = _createForOfIteratorHelper$1($node.querySelectorAll(selector)),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _$el$innerText;

          var $el = _step.value;

          var _text = (_$el$innerText = $el.innerText) !== null && _$el$innerText !== void 0 ? _$el$innerText : $el.textContent;

          if (!string || _text === string) {
            if (multiple) {
              result = (result || []).concat($el);
            } else {
              return $el;
            }
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return result;
    }, {
      toString: function toString() {
        return "\"".concat(string, "\"");
      }
    });
  }
  function nth(n, selector) {
    var of = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'child';
    var isInt = Number.isInteger(n);
    var last = isInt && n < 0;

    if (last) {
      of = "last-".concat(of);
      n = Math.abs(n);
    }

    return assign(function ($node, multiple) {
      var sel = n != null ? "".concat(selector, ":nth-").concat(of, "(").concat(n, ")") : selector;
      return multiple ? $node.querySelectorAll(sel) : $node.querySelector(sel);
    }, {
      toString: function toString() {
        if (n == null) return selector;
        if (!isInt) return "the nth(".concat(n, ") ").concat(selector);
        if (last && n === 1) return "the last ".concat(selector);
        var teen = Array.from("".concat(n)).reverse()[1] === '1';
        var th = !teen && ['', 'st', 'nd', 'rd'][n % 10] || 'th';
        return "the ".concat(n).concat(th, " ").concat(last ? 'last' : '', " ").concat(selector);
      }
    });
  }

  var selectors = /*#__PURE__*/Object.freeze({
    __proto__: null,
    xpath: xpath,
    text: text$1,
    nth: nth
  });

  function Interactor(selector, properties) {
    var _this = this;

    if (properties) {
      return Interactor.extend(properties)(selector);
    } else if (!(this instanceof Interactor)) {
      return new Interactor(selector);
    }

    m.set(this, {
      selector: this.constructor.selector(selector),
      timeout: this.constructor.timeout,
      interval: 10,
      keyboard: {},
      queue: [],
      nested: false,
      parent: null,
      top: true
    });
    defineProperty$1(this, 'assert', {
      configurable: true,
      get: function get() {
        var a = InteractorAssert(_this);
        defineProperty$1(_this, 'assert', {
          configurable: true,
          value: a
        });
        return a;
      }
    });
  }
  defineProperties(Interactor, {
    name: {
      writable: true,
      value: ''
    },
    timeout: {
      writable: true,
      value: 2000
    },
    Error: {
      value: InteractorError
    },
    extend: {
      value: extend
    },
    assertion: {
      value: assertion
    },
    selector: {
      configurable: true,
      get: function get() {
        return function (s) {
          return s;
        };
      },
      set: function setSelectorFn(selector) {
        defineProperty$1(this, 'selector', {
          configurable: true,
          get: function get() {
            return typeof selector === 'string' ? function (s) {
              return s !== null && s !== void 0 ? s : selector;
            } : selector;
          },
          set: setSelectorFn
        });
      }
    },
    dom: {
      configurable: true,
      get: function get() {
        return window;
      },
      set: function setDOM(win) {
        defineProperty$1(this, 'dom', {
          configurable: true,
          get: typeof win === 'function' ? win : function () {
            return win;
          },
          set: setDOM
        });
      }
    },
    suppressLayoutEngineWarning: {
      configurable: true,
      get: function get() {
        return !!getPrototypeOf(this).constructor.suppressLayoutEngineWarning;
      },
      set: function suppressLayoutEngineWarning(bool) {
        defineProperty$1(this, 'suppressLayoutEngineWarning', {
          configurable: true,
          get: function get() {
            return !!bool;
          },
          set: suppressLayoutEngineWarning
        });
      }
    },
    find: {
      value: assign(function find(selector) {
        return m.new(Interactor(selector), 'nested', true);
      }, selectors)
    }
  });
  assign(Interactor.prototype, {
    $: function $(selector) {
      return query.call(this, selector);
    },
    $$: function $$(selector) {
      return query.call(this, selector, true);
    },
    timeout: function timeout(ms) {
      return ms ? m.new(m.top(this), 'timeout', ms) : m.get(m.top(this), 'timeout');
    },
    find: function find(selector) {
      var q = m.get(selector, 'queue');
      var i = q ? selector : Interactor(selector);

      if ((q || m.get(i, 'queue')).length) {
        throw InteractorError('the provided interactor must not have queued actions');
      }

      return m.set(m.new(i, 'parent', this), 'nested', true);
    },
    assert: function assert(assertion) {
      return m.new(m.top(this), 'queue', {
        type: 'assert',
        fn: assertion,
        ctx: this
      });
    },
    exec: function exec(callback) {
      var _this2 = this;

      if (m.get(callback, 'queue')) {
        var _m$get = m.get(callback),
            queue = _m$get.queue,
            keyboard = _m$get.keyboard;

        queue = queue.map(function (a) {
          return assign({}, a, {
            ctx: m.new(a.ctx, 'parent', _this2)
          });
        });
        return m.new(m.top(this), {
          keyboard: keyboard,
          queue: queue
        });
      } else {
        return m.new(m.top(this), 'queue', {
          type: 'exec',
          fn: callback,
          ctx: this
        });
      }
    },
    catch: function _catch(handler) {
      if (typeof handler === 'string') {
        var message = handler;

        handler = function handler(err) {
          if (err.name === 'InteractorError') {
            throw err.format(message);
          } else {
            throw err;
          }
        };
      }

      return m.new(m.top(this), 'queue', {
        type: 'catch',
        fn: handler,
        ctx: this
      });
    },
    then: function then() {
      var _queue$reduce;

      var _m$get2 = m.get(this),
          queue = _m$get2.queue,
          timeout = _m$get2.timeout,
          interval = _m$get2.interval;

      var assertion;
      return (_queue$reduce = queue.reduce(function (promise, action, i) {
        var type = action.type,
            ctx = action.ctx,
            fn = action.fn;
        if (!fn) type = null;

        var bind$ = function bind$(fn, f) {
          return named(fn.name, function () {
            if (f) f();
            return fn.length ? fn.call(ctx, ctx.$()) : fn.call(ctx);
          });
        };

        var onError = function onError(err) {
          throw err.name === 'InteractorError' ? err.bind(ctx) : err;
        };

        if (type === 'assert') {
          assertion = bind$(fn, assertion);
        }

        if (assertion && (type !== 'assert' || i === queue.length - 1)) {
          promise = promise.then(when(assertion, {
            remains: action.remains,
            interval: interval,
            timeout: timeout
          })).catch(onError);
          assertion = null;
        }

        if (type === 'exec') {
          promise = promise.then(bind$(fn)).catch(onError);
        } else if (type === 'catch') {
          promise = promise.catch(fn.bind(ctx));
        }

        return promise;
      }, Promise.resolve())).then.apply(_queue$reduce, arguments);
    },
    toString: function toString() {
      var name = this.constructor.name;

      var _m$get3 = m.get(this),
          parent = _m$get3.parent,
          selector = _m$get3.selector;

      var string = (selector === null || selector === void 0 ? void 0 : selector.toString()) || '';
      if (name) string += " ".concat(name);

      if (parent && m.get(parent, 'selector')) {
        string += "".concat(string && ' within ').concat(parent);
      }

      return string;
    }
  });
  defineInteractorProperties(Interactor.prototype, assign({}, actions, properties));

  assign(Interactor, map(actions, function (action, name) {
    return named(name, function (selector) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      return action.apply(m.get(selector, 'queue') ? selector : Interactor.find(selector), args);
    });
  }));
  assign(Interactor, map(properties, function (_ref, name) {
    var _get = _ref.get,
        value = _ref.value,
        assert = _ref.assert;
    return named(name, function () {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      var selector = _get || value && args.length > value.length ? args.shift() : '';
      var assertion = assert || createAssert(name, _get || value);

      var ctx = function ctx(i) {
        return selector ? i.find(selector) : i;
      };

      var thennable = when(function () {
        if (!selector) throw InteractorError('an element selector is required when awaiting on properties');
        return (_get || value).apply(Interactor.find(selector), args);
      });
      return {
        then: thennable.then,
        catch: thennable.catch,
        get: function get() {
          return (_get || value).apply(ctx(this), args);
        },
        assert: function assert(expected) {
          for (var _len3 = arguments.length, a = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
            a[_key3 - 1] = arguments[_key3];
          }

          return ctx(this).assert(named(name, function () {
            assertion.apply(this, [expected].concat(args, a));
          }));
        }
      };
    });
  }));

  exports.InteractorError = InteractorError;
  exports.assertion = assertion;
  exports.default = Interactor;
  exports.when = when;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
